## clisp 2.49.20170913

=== doc/Makefile ===
# CLISP Implementation Notes generation
# (c) 2000-2011 Sam Steingold

# To generate HTML, you will need xsltproc & xmllint from the libxml2
# (http://xmlsoft.org/) package in addition to the DocBook DTDs and XSL
# stylesheets (http://www.docbook.org/)
# When writing docbook documentation, you need the "DocBook Definitive Guide"
# http://docbook.org/tdg/en/html/docbook-x.html

# which DTD to validate against
DTDVER=4.5

# all included XML files
IMPNOTES=cl-ent.xml clhs-ent.xml impbody.xml impent.xml mop.xml gray.xml     \
	impext.xml impissue.xml impbyte.xml unix-ent.xml mop-ent.xml faq.xml \
	history.xml \
	../modules/asdf/asdf.xml	        \
	../modules/berkeley-db/berkeley-db.xml	\
	../modules/berkeley-db/ent-bdb.xml	\
	../modules/dbus/dbus.xml		\
	../modules/dirkey/dirkey.xml		\
	../modules/fastcgi/fastcgi.xml		\
	../modules/gdbm/gdbm.xml		\
	../modules/gtk2/gtk.xml			\
	../modules/i18n/i18n.xml		\
	../modules/libsvm/svm.xml		\
	../modules/matlab/matlab.xml		\
	../modules/netica/netica.xml		\
	../modules/oracle/oracle.xml		\
	../modules/pari/pari.xml		\
	../modules/pcre/pcre.xml		\
	../modules/postgresql/postgresql.xml	\
	../modules/rawsock/rawsock.xml		\
	../modules/readline/readline.xml	\
	../modules/regexp/regexp.xml		\
	../modules/syscalls/syscalls.xml	\
	../modules/zlib/zlib.xml
# all used stylesheets
CLISP_XSL = chunk.xsl common.xsl fo.xsl id-href-map.xsl man.xsl pile.xsl
CLISP_CSS = impnotes.css
# targets for <olink> resolution
OLINK = man.tdb clink.tdb pile.tdb chunk.tdb olink-pile.xml olink-chunk.xml

RM=/bin/rm -f
CURDIR=$(shell pwd)

# what to do when there is no local system-wide DTD & XSL?
DOWNLOAD=yes

ifneq (,$(filter Windows%,$(OS)))
DTD_PATH=$(firstword $(wildcard ./docbook-dtd*/docbookx.dtd \
	/usr/share/docbook-xml$(DTDVER)/docbookx.dtd))
# Make sure to use a trailing slash.
XSL_PATH=$(firstword $(wildcard ./docbook-xsl*/ \
	/usr/share/docbook-xsl*/))
FOP=/cygdrive/c/java/fop-0.20.5/fop.bat
else
DTD_PATH=$(firstword $(wildcard ./docbook-dtd*/docbookx.dtd \
	/usr/share/sgml/docbook/xml-dtd-$(DTDVER)*/docbookx.dtd \
	/usr/share/xml/docbook/schema/dtd/$(DTDVER)*/docbookx.dtd))
XSL_PATH=$(firstword $(wildcard ./docbook-xsl*/ \
	/usr/share/sgml/docbook/xsl-stylesheets-1*/ \
	/usr/share/xml/docbook/stylesheet/nwalsh*/))
FOP=../../../fop/fop
endif

IN_FILES = impnotes.xml clisp.xml clisp-link.xml
# common dependencies for all checkers
CHECK_DEPS = $(IN_FILES)
ifeq (,$(wildcard $(DTD_PATH))) # DTD does not exist
ifeq (yes,$(DOWNLOAD))		# download once
CHECK_DEPS += docbook-dtd
DTD_PATH=./docbook-dtd/docbookx.dtd
else # download on each check (you need network-aware tools to use it)
# this is the original DTD
DTD_PATH=http://www.oasis-open.org/docbook/xml/$(DTDVER)/docbookx.dtd
#DTD_PATH=http://www.docbook.org/xml/$(DTDVER)/docbookx.dtd
endif
endif

# common dependencies for all generators
GEN_DEPS = common.xsl
ifeq (,$(wildcard $(XSL_PATH))) # stylesheets do not exist
ifeq (yes,$(DOWNLOAD))	        # download once
GEN_DEPS += docbook-xsl
XSL_PATH=./docbook-xsl/
else # download on each build (you need network-aware tools to use it)
XSL_PATH=http://docbook.xml-doc.org/snapshots/xsl/
# XSL_PATH=http://docbook.sourceforge.net/release/xsl/snapshot/
# XSL_PATH=http://docbook.sourceforge.net/release/xsl/current/
endif
endif

# The xmlcatalog utility (from libxml2)
XMLCATALOG=xmlcatalog

# chose one:
#TEXI2HTML=texi2html -monolithic -verbose $< -out_file $@
TEXI2HTML=makeinfo --verbose --no-split --no-headers --force --html $< -o $@

# NB: keep in sync with src/makemake.in:MYIMPROOT
DIST_SFBETA = sds,clisp@web.sf.net:/home/groups/c/cl/clisp/htdocs/beta
DIST =
RSYNC = rsync -avC --copy-unsafe-links
CHMOD = chmod -R a+rX

##### nothing user-serviceable below #####

# name of XML catalog file to create
# (if not specified, no local catalog created or used)
CATALOG_FILE=catalog.xml

# Stylesheets URI used internally in the CLISP project *.xsl files.
XSL_URI=http://docbook.sourceforge.net/release/xsl/current/

FILLIN=. ../version.sh && sed -e 's,@DTD@,$(DTD_PATH),' \
	    -e 's,@DTDVER@,$(DTDVER),' \
	    -e 's,@VERSION@,'$${VERSION_NUMBER}',' \
	    -e 's,@TODAY@,'`date +"%Y-%m-%d"`','

# cannot use profiling <http://www.sagehill.net/docbookxsl/Profiling.html>
# because that would require XSL tools to be installed on user machine
SGML_UNCOMMENT=-e 's/^<!--\#\(.*\)-->$$/\#\1/'

E=\ *<!--\(\#[^-]*\)--> *
ROFF_UNCOMMENT=-e 's/^$E$$/\1/' -e 's/$E$$/\n\1/' -e 's/^$E/\1\n/' -e 's/$E/\n\1\n/g'

.PHONY : all up count search clean

all: check impnotes.html regexp.html man

ifneq (,$(CATALOG_FILE))
# depends on Makefile because of $(XSL_PATH)
# gnu license xml files specify a bad dtd file
GNU_DTD = http://www.oasis-open.org/docbook/xml/$(DTDVER)/docbookx.dtd
$(CATALOG_FILE): Makefile
	$(RM) $(CATALOG_FILE)
	$(XMLCATALOG) --create > $(CATALOG_FILE)
	$(XMLCATALOG) --noout --add "rewriteURI" \
		$(XSL_URI) $(XSL_PATH) $(CATALOG_FILE)
	$(XMLCATALOG) --noout --add "rewriteSystem" \
		$(XSL_URI) $(XSL_PATH) $(CATALOG_FILE)
	$(XMLCATALOG) --noout --add "rewriteURI" \
		$(GNU_DTD) $(DTD_PATH) $(CATALOG_FILE)
XSLTPROC=XML_CATALOG_FILES="$(CATALOG_FILE) ${XML_CATALOG_FILES}" xsltproc
else
XSLTPROC=xsltproc
endif
XMLS_COMMON = --timing --xinclude
GOOGLEADS=0

# target.database.document in this command is a workaround for bug
#   warning: failed to load external entity \"olinkdb.xml\"
#   Olink error: could not open target database \'olinkdb.xml\'.
# https://sourceforge.net/p/docbook/bugs/1111/
MAKE_TDB=$(XSLTPROC) $(XMLS_COMMON) --stringparam collect.xref.targets "only" \
  --stringparam target.database.document "olink-pile.xml" \
	--stringparam targets.filename

man.tdb: clisp.xml pile.xsl $(GEN_DEPS) $(CATALOG_FILE)
	$(MAKE_TDB) "$@" pile.xsl $<

clink.tdb: clisp-link.xml pile.xsl $(GEN_DEPS) $(CATALOG_FILE)
	$(MAKE_TDB) "$@" pile.xsl $<

pile.tdb: impnotes.xml $(IMPNOTES) pile.xsl $(GEN_DEPS) $(CATALOG_FILE)
	$(MAKE_TDB) "$@" pile.xsl $<

chunk.tdb: impnotes.xml $(IMPNOTES) chunk.xsl $(GEN_DEPS) $(CATALOG_FILE)
	$(MAKE_TDB) "$@" chunk.xsl $<

ifneq (,$(wildcard ../version.sh))
clisp.xml: clisp.xml.in ../version.sh Makefile
	$(RM) $@
	$(FILLIN) $< > $@

clisp-link.xml: clisp-link.xml.in ../version.sh Makefile
	$(RM) $@
	$(FILLIN) $< > $@

impnotes.xml: impnotes.xml.in $(IMPNOTES) ../version.sh Makefile
	$(RM) $@
	$(FILLIN) $< > $@
endif

XMLOUT=$(XSLTPROC) $(XMLS_COMMON) --param google.ads $(GOOGLEADS) \
	--stringparam target.database.document
DOC_MAN = --stringparam current.docid "man"
DOC_CLK = --stringparam current.docid "clink"
DOC_IMP = --stringparam current.docid "impnotes"

CHECK_IDS = if egrep -Hnr 'id="id[0-9]*"' $@; then exit 1; else true; fi

clisp.html: clisp.xml $(GEN_DEPS) pile.xsl $(OLINK)
	$(XMLOUT) "olink-pile.xml" $(DOC_MAN) -o $@ pile.xsl $<
	$(CHECK_IDS)

clisp.1: clisp.xml $(GEN_DEPS) man.xsl $(OLINK)
	$(XMLOUT) "olink-pile.xml" $(DOC_MAN) -o $@ man.xsl $<

clisp-link.html: clisp-link.xml $(GEN_DEPS) pile.xsl $(OLINK)
	$(XMLOUT) "olink-pile.xml" $(DOC_CLK) -o $@ pile.xsl $<
	$(CHECK_IDS)

clisp-link.1: clisp-link.xml $(GEN_DEPS) man.xsl $(OLINK)
	$(XMLOUT) "olink-pile.xml" $(DOC_CLK) -o $@ man.xsl $<

_%.html: %.html
	sed $(SGML_UNCOMMENT) $< > $@

_%.1: %.1
	sed $(ROFF_UNCOMMENT) $< > $@

check: $(IMPNOTES) $(CHECK_DEPS)
	for f in $(IN_FILES); do \
	  xmllint $(XMLS_COMMON) --noout --postvalid --noent $$f; done

impnotes.texi: impnotes.xml $(IMPNOTES)
	time docbook2texi $<

impnotes.html: impnotes.xml $(IMPNOTES) $(GEN_DEPS) pile.xsl $(OLINK)
	$(XMLOUT) "olink-pile.xml" $(DOC_IMP) -o $@ pile.xsl $<
#	cp impnotes.html impnotes-saved.html
#	tidy -config tidy.conf -f tidy.err impnotes.html || true
	$(CHECK_IDS)
	(test -n "$(DIST)" && $(CHMOD) impnotes.html impnotes.css && \
	 $(RSYNC) impnotes.html impnotes.css $(DIST)/) || true

man: _clisp.html _clisp.1 _clisp-link.html _clisp-link.1
	(cd ../build && make clisp.html clisp.1 && \
	 $(CHMOD) clisp.1 clisp.html && \
	 test -n "$(DIST)" && $(RSYNC) clisp.1 clisp.html $(DIST)/) || true

impnotes.fo: impnotes.xml $(IMPNOTES) fo.xsl $(XSL_TARGET)
	$(XMLOUT) "olink-pile.xml" $(DOC_IMP) -o $@ fo.xsl $<

# http://xmlgraphics.apache.org/fop/
impnotes.pdf: impnotes.fo
	${FOP} $< $@

id-href.map : chunk.tdb
	$(XSLTPROC) $(XMLS_COMMON) -o $@ id-href-map.xsl $<

html: impnotes.xml $(IMPNOTES) $(GEN_DEPS) chunk.xsl pile.xsl clisp.xml $(OLINK) id-href.map
	if [ ! -h $@ ]; then $(RM) -r $@; \
	  if [ -d ../../sf/www/impnotes ]; then ln -s ../../sf/www/impnotes $@; \
	  elif [ -d ../../www/impnotes ]; then ln -s ../../www/impnotes $@; \
	  else echo 'no sf/www dir'; false; fi; fi
	cd $@/ && grep -v -e "^#" .symlinks | sed 's/^/ln -vf /' | sh -
	cp -pv impnotes.css id-href.map $@/
	$(XMLOUT) "olink-chunk.xml" $(DOC_IMP) -o $@/ chunk.xsl $<
	$(XMLOUT) "olink-chunk.xml" $(DOC_MAN) -o $@/clisp.html pile.xsl clisp.xml
	$(XMLOUT) "olink-chunk.xml" $(DOC_CLK) -o $@/clisp-link.html pile.xsl clisp-link.xml
	sed $(SGML_UNCOMMENT) $@/clisp.html > _clisp-1.html
	sed $(SGML_UNCOMMENT) $@/clisp-link.html > _clisp-link-1.html
	cd ../build; make clisp-1.html clisp-link-1.html;
	mv -f ../build/clisp-1.html $@/clisp.html
	mv -f ../build/clisp-link-1.html $@/clisp-link.html
	rm -f _clisp-1.html _clisp-link-1.html
	$(CHECK_IDS)
	cd html; cd ..; $(CURDIR)/../utils/fix-perms.sh
	(test -n "$(DIST)" && $(CHMOD) $@ impnotes.css && \
	 $(RSYNC) $@/*.html $@/id-href.map impnotes.css $(DIST)/impnotes/) \
	|| true

# try to use http://www.graphviz.org/ instead of openoffice for MOP
# class inheritance diagrams
mop-classes.png : mop-classes.dot
	dot -Tpng mop-classes.dot -o mop-classes.png

up: impnotes.html html
	mv html impnotes
	$(CHMOD) impnotes.html impnotes
	$(RSYNC) impnotes.html impnotes $(DIST_SFBETA)
	mv impnotes html

regexp.html: ../modules/regexp/regexp.texinfo
	$(TEXI2HTML)

clean: force
	$(RM) impnotes.texi impnotes.html impnotes.pdf html \
	  clisp.html clisp.1 *.tdb $(CATALOG_FILE) impnotes.fo \
	  id-href.map clisp-link.html clisp-link.1
	test -f impnotes.xml.in && $(RM) impnotes.xml
	test -f clisp.xml.in && $(RM) clisp.xml
	test -f clisp-link.xml.in && $(RM) clisp-link.xml

count: $(IMPNOTES)
	wc $^

DTD_DOWNLOAD=http://www.docbook.org/xml/$(DTDVER)/docbook-xml-$(DTDVER).zip
docbook-dtd :
	mkdir docbook-dtd && cd docbook-dtd && \
	  wget -O docbook-xml.zip $(DTD_DOWNLOAD) && \
	  unzip docbook-xml.zip && $(RM) docbook-xml.zip

#XSL_DOWNLOAD=https://sourceforge.net/projects/docbook/files/latest/download?source=files
XSL_VERSION=1.79.1
XSL_DOWNLOAD=https://downloads.sourceforge.net/project/docbook/docbook-xsl/$(XSL_VERSION)/docbook-xsl-$(XSL_VERSION).zip
docbook-xsl :
	wget $(XSL_DOWNLOAD) && unzip docbook-xsl-$(XSL_VERSION).zip && \
	  mv -v docbook-xsl-$(XSL_VERSION) docbook-xsl && \
	  $(RM) docbook-xsl-$(XSL_VERSION).zip
	grep '<fm:Version>' docbook-xsl/VERSION

IMPNOTES_SRC = impnotes-src
$(IMPNOTES_SRC).zip : Makefile impnotes.xml clisp.xml clisp-link.xml \
		$(IMPNOTES) $(CLISP_XSL) $(CLISP_CSS)
	$(RM) -r $@ $(IMPNOTES_SRC)
	mkdir $(IMPNOTES_SRC);
	for f in $^; do sed 's,\.\./modules/[^/]*/,,' $$f > $(IMPNOTES_SRC)/`basename $$f`; done
	zip -9mvr $@ $(IMPNOTES_SRC)
	(test -n "$(DIST)" && $(CHMOD) $@ ../src/NEWS && \
	 $(RSYNC) $@ ../src/NEWS $(DIST)/) || true

SEARCH=
search: force
	@if test -z "$(SEARCH)"; then echo "usage: make search SEARCH=string"; \
	else grep -n -- '$(SEARCH)' $(IMPNOTES) $(addsuffix .in, $(IN_FILES)); fi

force:

=== modules/queens/Makefile ===
# Makefile for the sample CLISP module QUEENS

srcdir = .

# Programs used by "make":
CC = gcc -O
CPPFLAGS =
CFLAGS = -Wall -fomit-frame-pointer -O2
CPP = gcc -O -E -w
CLFLAGS =
CLISP = clisp -q -norc
CLISP_LINKKIT = $$($(CLISP) -b)/linkkit

LN = ln
LN_S = ln -s

MAKE = make

SHELL = /bin/sh

GENERATED = queens.o callqueens.o link.sh
DISTRIBFILES = Makefile $(GENERATED)
distribdir =

# default target: make the module
clisp-module : $(GENERATED)

queens.o : $(srcdir)/queens.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $(srcdir)/queens.c

callqueens.m.c : $(srcdir)/callqueens.c
	$(CLISP) -C $(CLISP_LINKKIT)/modprep $(srcdir)/callqueens.c ./

callqueens.o : callqueens.m.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -I$(CLISP_LINKKIT) \
		-c callqueens.m.c -o callqueens.o

link.sh : $(srcdir)/link.sh
	$(LN_S) $(srcdir)/link.sh .

# Make a module distribution into $(distribdir)
clisp-module-distrib : clisp-module force
	$(LN) $(DISTRIBFILES) $(distribdir)

clean : force
	rm -f core *.o *.a *.m.c *.fas *.lib

distclean : clean

force :

=== debian/changelog ===
clisp (1:2.49.20170913-4build1) bionic; urgency=medium

  * Rebuild against new libgdbm5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Feb 2018 15:23:21 +0100

clisp (1:2.49.20170913-4) unstable; urgency=medium

  * Always build with FFI.
    ffcall now builds and passes testsuite on all release architectures and most
    non-release ones. (Closes: #385490)
  * glibc-2.26.patch: new patch, fixes FTBFS against glibc 2.26.
    (Closes: #880686)
  * On mipsel, re-enable -O2 optimization.
    But add -fno-split-wide-types to avoid FTBFS (still need to determine
    whether it is a compiler bug or a wrong assumption of clisp).
  * No longer directly set DEB_HOST_ARCH (use /usr/include/dpkg/architecture.mk)
  * Drop common-lisp-controller (CLC) integration.
  * Drop obsolete preinst script.

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 27 Nov 2017 17:09:11 +0100

clisp (1:2.49.20170913-3) unstable; urgency=medium

  * bump-fasl-loader-version.patch: new patch, bumps ABI version.
    Thanks to Agustin Martin (Closes: #877223)
  * Rewrite d/rules using dh.
  * Register manual and impnotes into doc-base.
  * d/watch: use secure URL, bump to format version 4.
  * Install manpages using dh_installman.
  * Make binary packages arch:any (except those requiring FFI).
  * Remove special flags for m68k, alpha and hppa.
  * No longer hardcode version number in d/rules and d/*.install.
  * Remove obsolete Breaks against c-l-c and cl-adsf.
  * Strip extra "clisp" subdir from documentation install path.
  * Add ghostscript to Build-Depends, for PDF documentation.
  * Remove obsolete Pre-Depends on ${xlibs:PreDepends}.
  * Enforce strict versioned dependency of modules on clisp main package.
  * Bump Standards-Version to 4.1.1.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 21 Oct 2017 09:59:53 +0200

clisp (1:2.49.20170913-2) unstable; urgency=medium

  * fix-unpack_sstring_alloca_help_.patch: new patch, fixes FTBFS on 32-bit
    little-endian archs.
  * Disable FFI on mips.
  * stream-flags-alignment.patch: new patch, fixes FTBFS on mips.
  * The above changes together should fix FTBFS on armel, armhf, i386, mips and
    mipsel. (Closes: #598152, #751005)
  * Do not use --enable-portability on x86 archs.
  * maxlenpath.patch: new patch by Flavio Cruz. Fixes FTBFS on hurd-i386.
    (Closes: #805701, #801260)
  * Add support for arm64, mips64el, ppc64 and ppc64el.
  * Enable FFI on powerpc.
  * Drop references to dead architectures (ia64, sparc, s390).
  * Use DEB_HOST_ARCH instead of DEB_BUILD_ARCH for determining
    architecture of packages to be built.
  * Add myself to Uploaders.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 23 Sep 2017 21:09:17 +0200

clisp (1:2.49.20170913-1) unstable; urgency=medium

  * Rebuild for new libffcall ABI. 
  * Add missing missing build-{arch,indep} targets. Thanks for the patch to
    Santiago Vila. (Closes: #821973)
  * Make clisp-doc Multi-Arch: foreign
  * Imported upstream snapshot of 13 September 2017. This once fixes:
    - the find -perm syntax being outdated. (Closes: #724767)

 -- Peter Van Eynde <pvaneynd@debian.org>  Sat, 01 Jul 2017 08:38:16 +0200

clisp (1:2.49.60+-2) unstable; urgency=medium

  * Use '--enable-portability' as per advice of Bruno Haible. 
    this should help with the buildd problems.

 -- Peter Van Eynde <pvaneynd@debian.org>  Fri, 30 Jun 2017 21:07:54 +0200

=== debian/control ===
Source: clisp
Section: lisp
Priority: optional
Maintainer: Debian Common Lisp Team <pkg-common-lisp-devel@lists.alioth.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
           Christoph Egger <christoph@debian.org>,
           Sébastien Villemot <sebastien@debian.org>
Build-Depends:
 debhelper (>> 10),
 gettext,
 bison,
 libncurses5-dev,
 groff,
 ghostscript,
 libx11-dev,
 libxext-dev,
 libxpm-dev,
 libsigsegv-dev (>= 2.11),
 libreadline-gplv2-dev,
 dh-lisp (>= 0.7.1),
 libdb-dev,
 libffcall-dev,
 libgdbm-dev,
 libpq-dev,
 libpcre3-dev,
 libdbus-1-dev,
 zlib1g-dev
Build-Conflicts: libsigsegv-dev (<= 2.8), libreadline6-dev
Standards-Version: 4.1.1
Homepage: http://www.clisp.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-common-lisp/clisp.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-common-lisp/clisp.git/

Package: clisp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: lisp-compiler, ${clisp:fasl-version}
Suggests: gdb, clisp-doc, clisp-dev, slime
Description: GNU CLISP, a Common Lisp implementation
 ANSI Common Lisp is a high-level, general-purpose programming language.
 GNU CLISP is a Common Lisp implementation by Bruno Haible of Karlsruhe
 University and Michael Stoll of Munich University, both in Germany.
 It mostly supports the Lisp described in the ANSI Common Lisp standard.
 It runs on most Unix workstations (GNU/Linux, FreeBSD, NetBSD, OpenBSD,
 Solaris, Tru64, HP-UX, BeOS, NeXTstep, IRIX, AIX and others) and on
 other systems (Windows NT/2000/XP, Windows 95/98/ME) and needs only
 4 MB of RAM.
 .
 It is Free Software and may be distributed under the terms of GNU GPL,
 while it is possible to distribute commercial proprietary applications
 compiled with GNU CLISP.
 .
 The user interface comes in English, German, French, Spanish, Dutch,
 Russian and Danish, and can be changed at run time.
 GNU CLISP includes an interpreter, a compiler, a debugger, CLOS, MOP,
 a foreign language interface, sockets, i18n, fast bignums and more.
 An X11 interface is available through CLX, Garnet, CLUE/CLIO.
 GNU CLISP runs Maxima, ACL2 and many other Common Lisp packages.

Package: clisp-dev
Architecture: any
Depends: clisp (= ${binary:Version}), ${misc:Depends}
Description: GNU CLISP, a Common Lisp implementation (development files)
 This is the link kit of clisp, it can be used to add external modules (written
 for example in C) to the implementation. The module can define new
 variables, symbols and functions for use in clisp. Examples include
 database interfaces or widget libraries. Normal users do not need
 this.
 .
 See also http://clisp.cons.org/impnotes.html#modules
 .
 ANSI Common Lisp is a high-level, general-purpose programming language.
 GNU CLISP is a Common Lisp implementation by Bruno Haible of Karlsruhe
 University and Michael Stoll of Munich University, both in Germany.
 It mostly supports the Lisp described in the ANSI Common Lisp standard.
 It runs on most Unix workstations (GNU/Linux, FreeBSD, NetBSD, OpenBSD,
 Solaris, Tru64, HP-UX, BeOS, NeXTstep, IRIX, AIX and others) and on
 other systems (Windows NT/2000/XP, Windows 95/98/ME) and needs only
 4 MB of RAM.

Package: clisp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GNU CLISP, a Common Lisp implementation (documentation)
 This is the documentation for clisp.
 .
 ANSI Common Lisp is a high-level, general-purpose programming language.
 GNU CLISP is a Common Lisp implementation by Bruno Haible of Karlsruhe
 University and Michael Stoll of Munich University, both in Germany.
 It mostly supports the Lisp described in the ANSI Common Lisp standard.
 It runs on most Unix workstations (GNU/Linux, FreeBSD, NetBSD, OpenBSD,
 Solaris, Tru64, HP-UX, BeOS, NeXTstep, IRIX, AIX and others) and on
 other systems (Windows NT/2000/XP, Windows 95/98/ME) and needs only
 4 MB of RAM.


Package: clisp-module-berkeley-db
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds an interface to Berkeley DB
 This adds a module to clisp that implements an interface to the
 Berkeley DB.

Package: clisp-module-pcre
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds libpcre support
 This adds a module to clisp that implements an interface to the
 libpcre which implements Perl-compatible regular expressions.

Package: clisp-module-bindings-glibc
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds the glibc bindings
 This adds a module to clisp that implements an interface to the
 glibc library, adding support for a number of low level functions.

Package: clisp-module-postgresql
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds a PostgreSQL interface
 This adds a module to clisp that implements an interface to the
 PostgreSQL DB using the C bindings.

Package: clisp-module-clx
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds X11 bindings
 This adds a module to clisp that implements an interface to the
 X11 called CLX.

Package: clisp-module-rawsock
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds a low level socket interface
 This adds a module to clisp that implements an interface to the
 socket interfaces.

Package: clisp-module-dbus
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds an interface to D-Bus
 This adds a module to clisp that implements an interface to the
 D-Bus system.

Package: clisp-module-gdbm
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds an interface to GNU DBM
 This adds a module to clisp that implements an interface to
 GNU DBM.

Package: clisp-module-zlib
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Description: clisp module that adds zlib support for vectors
 This adds a module to clisp that implements a zlib interface,
 allowing you to compress vectors using zlib.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

VERSION_NUMBER := $(shell grep '^VERSION_NUMBER=' < version.sh | sed s/^VERSION_NUMBER=//)

# check if we need to use DEBUG:
DEBUG_FLAGS:=$(if $(findstring debug,$(DEB_BUILD_OPTIONS)),--with-debug,)

#standard C flags:
CFLAGS:=-falign-functions=4
export CFLAGS

# Use --enable-portability on most archs except the best-supported ones (x86, ppc64*)
ifeq (,$(filter amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-i386 ppc64 ppc64el,$(DEB_HOST_ARCH)))
PORTABILITY_FLAG := --enable-portability
endif

ifneq (,$(filter armhf ,$(DEB_HOST_ARCH)))
	 CFLAGS:=-marm ${CFLAGS}
endif

FFI := --with-dynamic-ffi --with-dynamic-modules
MODULES := --with-module=gdbm --with-module=berkeley-db --with-module=pcre --with-module=rawsock --with-module=clx/new-clx --with-module=bindings/glibc --with-module=postgresql --with-module=zlib --with-module=dbus

%:
	dh $@

override_dh_auto_configure:
	# on systems without FFI we cannot make multiple packages
	./configure debian/build ${PORTABILITY_FLAG} ${DEBUG_FLAGS} --prefix=/usr --fsstnd=debian ${FFI} CFLAGS="${CFLAGS}" ${MODULES} || { cat debian/build/config.log; touch foo.h; cpp -dM foo.h ; exit 1; }

	# Add the -fno-split-wide-types flag on mipsel
ifeq ($(DEB_HOST_ARCH),mipsel)
	sed -i 's/ -O2 / -O2 -fno-split-wide-types /' debian/build/Makefile
endif

override_dh_auto_build:
	# build the package
	$(MAKE) -C debian/build

override_dh_auto_clean:
	rm -rf debian/build 

override_dh_auto_install:
	# install the package
	$(MAKE) -C debian/build DESTDIR=$(shell pwd)/debian/tmp install
	mkdir -p debian/tmp/usr/share/doc debian/tmp/usr/share/man debian/tmp/usr/sbin debian/tmp/usr/bin

	# remove unwanted upstream doc/ files
	rm debian/tmp/usr/share/doc/clisp/doc/clisp.1 \
		debian/tmp/usr/share/doc/clisp/doc/clisp-link.1 \
		debian/tmp/usr/share/doc/clisp/COPYRIGHT \
		debian/tmp/usr/share/doc/clisp/GNU-GPL || true

override_dh_install:
	dh_install --sourcedir=debian/tmp

	# remove docs from the clx package
	if [ -d debian/clisp-module-clx/usr/lib/clisp-$(VERSION_NUMBER)/clx/new-clx/demos ] ; then rm -rf debian/clisp-module-clx/usr/lib/clisp-$(VERSION_NUMBER)/clx/new-clx/demos ; fi 

	# handle full image if  it exists, normally we do not build it
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then mkdir -p debian/clisp-dev/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then mkdir -p debian/clisp/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0644  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/*.a debian/clisp-dev/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0644  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/*.h debian/clisp-dev/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0644  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/makevars debian/clisp-dev/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0644  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/lispinit.mem debian/clisp/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0755  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/lisp.run debian/clisp/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi
	if [ -d debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full ] ; then install --owner=root --group=root --mode=0644  debian/tmp/usr/lib/clisp-$(VERSION_NUMBER)/full/*.o debian/clisp/usr/lib/clisp-$(VERSION_NUMBER)/full/ ; fi

override_dh_installchangelogs:
	dh_installchangelogs src/ChangeLog

override_dh_gencontrol-arch:
	# add FAS file format version to substvars
	debian/clisp/usr/bin/clisp -Efile utf-8 -B debian/clisp/usr/lib/clisp-$(VERSION_NUMBER) -M debian/clisp/usr/lib/clisp-$(VERSION_NUMBER)/base/lispinit.mem debian/fasl-version.lisp
	dh_gencontrol -a

## clisp 2.49.20180218+really2.49.92

=== utils/d2c/Makefile ===
# Makefile for doing various steps of .d -> .c conversion.
# Probably only works with GNU make.

here                   := $(shell pwd)
comment5               := $(here)/comment5
ansidecl               := $(here)/ansidecl
join-comments          := perl $(here)/join-c-comments.pl
fix-cpp-indent         := perl $(here)/fix-cpp-indent.pl
split-doubled-comments := perl $(here)/split-doubled-comments.pl
align-comments         := perl $(here)/align-comments.pl
conversions            := src utils

all:
	@echo "Pick a phase."

clean:
	rm -fv comment5 ansidecl ansidecl.c

convert: phase-1 phase-2 phase-3 phase-4 phase-5 # phase-6

PATCHED=$(shell egrep '^---' *.patch | sed -e 's,^[^/]*/,,' -e 's,	.*$$,,')
undo:
	cd ../../src; for f in *.ORIG; do mv -fv $$f `basename $$f .ORIG`; done
	cd ../;       for f in *.ORIG; do mv -fv $$f `basename $$f .ORIG`; done
	cd ../..; rm -fv $(PATCHED); cvs up $(PATCHED);

# Phase One: get rid of the #-style comments and the infrastructure
# that supports them. And convert all .d files to 7-bit ascii.

phase-1: $(addprefix convert-,$(conversions))

apply-patch-1:
	cd ../..; patch -p1 < $(here)/phase-1.patch

convert-%: comment5 apply-patch-1
	cd ../../$*; \
	for f in *.d; do \
	  cp $$f $$f.ORIG; \
	  $(comment5) $$f | $(join-comments) | $(fix-cpp-indent) > $$f.TMP; \
	  mv $$f.TMP $$f; \
	done

comment5: ../comment5.c
	gcc -o $@ $<

undo-phase-1:
	cd ../../utils; for f in *.d; do mv $$f.ORIG $$f; done
	cd ../../src; for f in *.d; do mv $$f.ORIG $$f; done
	cd ../..; patch -R -p1 < $(here)/phase-1.patch

# Phase Two: get rid of the idiosyncratic control-structure macros,
# elif, until, and loop.

phase-2: $(addprefix elif-until-and-loop-,$(conversions))

elif-until-and-loop-%:
	cd ../../$*;					    \
	for f in *.d; do				    \
	  cp $$f $$f.PHASE-1;				    \
	  perl $(here)/fix-elif-until.pl $$f.PHASE-1 > $$f; \
	done

undo-phase-2:
	cd ../../src; for f in *.d; do mv $$f.PHASE-1 $$f; done
	cd ../../utils; for f in *.d; do mv $$f.PHASE-1 $$f; done

# Phase Three: get rid of preprocessor macros global, local, and var.

phase-3: $(addprefix var-global-and-local-,$(conversions))

apply-patch-3:
	cd ../..; patch -p1 < $(here)/phase-3.patch

var-global-and-local-%: apply-patch-3
	cd ../../$*;						  \
	for f in *.d; do					  \
	  cp $$f $$f.PHASE-2;					  \
	  perl $(here)/fix-var-global-local.pl $$f.PHASE-2 > $$f; \
	done

undo-phase-3:
	cd ../../src; for f in *.d; do mv $$f.PHASE-2 $$f; done
	cd ../../utils; for f in *.d; do mv $$f.PHASE-2 $$f; done
	cd ../..; patch -R -p1 < $(here)/phase-3.patch


# Phase Four: run ansidecl to finally make .c files.

phase-4: ansidecl apply-patch-4
	cd ../../src;					       \
	for f in *.d; do				       \
	  cp $$f $$f.PHASE-3;				       \
	  cat $$f.PHASE-3 | $(ansidecl) > `basename $$f .d`.c; \
	  rm -f $$f;					       \
	done

apply-patch-4:
	cd ../../; patch -p1 < $(here)/phase-4.patch

ansidecl: ansidecl.c
	gcc -o $@ $<

ansidecl.c: ../ansidecl.d
	$(comment5) $< > $@



# We don't want to run the .c files that are really assembly code
# through indent because nothing good happens to 'em.

assembly += ari68020.c
assembly += ari80386.c
assembly += ariarm.c
assembly += arihppa.c
assembly += arimips.c
assembly += arimips64.c
assembly += arisparc.c
assembly += arisparc64.c
assembly += sp68000.c
assembly += sp80386.c
assembly += sp80386.msvc.c
assembly += spmips.c
assembly += spsparc.c
assembly += spsparc64.c

empty   :=
space   := $(empty) # don't delete this comment
to-skip := $(subst $(space), | ,$(assembly))

# Okay, this phase looks pretty silly. But it seems to be the recipe
# to get all the comments on the right lines relative to braces, etc.
phase-5:
	cd ../../src;						      \
	for f in *.d.ORIG; do					      \
	  name=`basename $$f .d.ORIG`;				      \
	  case $$name.c in					      \
	    $(to-skip) )					      \
	      echo "Skipping $$name.c";				      \
	      ;;						      \
	    *)							      \
	      cp $$name.c $$name.UNINDENTED-1;			      \
	      indent -gnu -i2 -lps $$name.c 2>$$name.indent-errors-1; \
	      cp $$name.c $$name.UNINDENTED-2;			      \
	      indent -kr -i2 -lps $$name.c 2>$$name.indent-errors-2;  \
	      cp $$name.c $$name.UNSPLIT;			      \
	      $(split-doubled-comments) $$name.UNSPLIT > $$name.c;    \
	      cp $$name.c $$name.UNINDENTED-3;			      \
	      indent -kr -i2 -lps $$name.c 2>$$name.indent-errors-3;  \
	      cp $$name.c $$name.UNALIGNED;			      \
	      $(align-comments) $$name.UNALIGNED > $$name.c;	      \
	      ;;						      \
	  esac;							      \
	done;							      \
	find . -name '*.indent-errors-*' -a -size 0b -exec rm {} \; ; \
	for n in 3 2 1; do					      \
	  for f in *.indent-errors-$$n; do			      \
	    name=`basename $$f .indent-errors-$$n`;		      \
	    mv $$name.UNINDENTED-$$n $$name.c;			      \
	  done							      \
	done

# Eventually we need to convert the generated makefiles. But we don't
# need it during builds and it's slow so we don't do it all the time.
# This should be run after all the patches have been applied.

phase-6: convert-makefiles

convert-makefiles:
	cd ../..; $(MAKE) -f Makefile.devel makefiles

clean-src:
	cd ../../src; rm -fv *.c~ *.d.ORIG *.d.PHASE-* *.UNINDENTED-* \
		*.indent-errors-* *.UNSPLIT *.UNALIGNED;
	cd ../; rm -fv *.d.ORIG *.d.PHASE-*;

=== debian/changelog ===
clisp (1:2.49.20180218+really2.49.92-3build3) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 10:33:57 +0000

clisp (1:2.49.20180218+really2.49.92-3build2) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 19:58:29 +0000

clisp (1:2.49.20180218+really2.49.92-3build1) disco; urgency=medium

  * Rebuild against new libgdbm6.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Nov 2018 15:01:24 +0100

clisp (1:2.49.20180218+really2.49.92-3) unstable; urgency=medium

  * socket-test.patch: new patch, fixes FTBFS on mips*, sparc64 and hurd-i386.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 14 Apr 2018 17:43:40 +0200

clisp (1:2.49.20180218+really2.49.92-2) unstable; urgency=medium

  * Disable parallelization when running the testsuite.
  * Drop clisp-hurd-einval-extra.patch: no longer needed.
  * ppc64el.patch: new patch, fixes FTBFS on ppc64el.
  * Set Maintainer to debian-common-lisp@l.d.o.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 12 Apr 2018 14:48:29 +0200

clisp (1:2.49.20180218+really2.49.92-1) experimental; urgency=medium

  * New upstream beta release (2.49.92).
  * d/copyright: reflect upstream changes.
  * Drop patches applied upstream:
    + memory-map-amd64.patch
    + memory-map-arm64.patch
    + memory-map-i386.patch
    + memory-map-mips.patch
    + memory-map-mips64.patch
    + memory-map-s390x.patch

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 18 Feb 2018 17:02:31 +0100

clisp (1:2.49.20180212+really2.49.90-2) experimental; urgency=medium

  * New patches sent by upstream, should fix some FTBFS:
    + memory-map-arm64.patch
    + memory-map-i386.patch
    + memory-map-mips.patch
    + memory-map-mips64.patch
    + memory-map-s390x.patch
  * Bump Standards-Version to 4.1.3.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 17 Feb 2018 09:35:19 +0100

clisp (1:2.49.20180212+really2.49.90-1) experimental; urgency=medium

  * New upstream beta release (2.49.90).
  * Update Vcs-* fields for salsa.
  * Remove patches applied upstream / no longer needed:
    + fix-unpack_sstring_alloca_help_.patch
    + glibc-2.26.patch
    + kfreebsd-amd64.diff
    + maxpathlen.patch
    + stream-flags-alignment.patch
  * Drop Build-Depends on dh-lisp.
  * Add Build-Depends on libunistring-dev.
  * Rewrite d/copyright using machine-readable format 1.0.
  * Build against latest libreadline-dev now that CLISP is GPL-2+.
  * Drop obsolete README.source.
  * Bump to debhelper compat level 11.
  * memory-map-amd64.patch: new patch, needed for newer kernels on amd64.
  * Simplify debian/rules, by using --builddirectory option to dh.
    In particular, dh_auto_test will now run the testsuite at build time.
    Also disable -fstack-protector-strong flag, and parallel build.
  * Add Build-Depends on locales-all, needed by the testsuite (which
    requires the en_US.utf8 locale).
  * Simplify package layout: merge clisp-dev, clisp-module-rawsock and
    clisp-module-bindings-glibc into main clisp package.
    Also add Suggests to other modules, which in turn declare an Enhances on
    clisp.
  * Build ASDF module (into main clisp package).
  * Remove -marm on armhf and -fno-split-wide-types on mipsel.
  * Drop bump-fasl-loader-version.patch (Closes: #886986)
  * Add virtual Provides on clisp-memfile-hash-NNNNNN, for use by reverse
    dependencies that embed a lisp image (like xindy).

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 13 Feb 2018 22:01:12 +0100

=== debian/control ===
Source: clisp
Section: lisp
Priority: optional
Maintainer: Debian Common Lisp Team <debian-common-lisp@lists.debian.org>
Uploaders: Peter Van Eynde <pvaneynd@debian.org>,
           Christoph Egger <christoph@debian.org>,
           Sébastien Villemot <sebastien@debian.org>
Build-Depends:
 debhelper (>= 11),
 gettext,
 bison,
 libncurses5-dev,
 groff,
 ghostscript,
 libx11-dev,
 libxext-dev,
 libxpm-dev,
 libsigsegv-dev (>= 2.11),
 libreadline-dev,
 libdb-dev,
 libffcall-dev,
 libgdbm-dev,
 libpq-dev,
 libpcre3-dev,
 libdbus-1-dev,
 zlib1g-dev,
 libunistring-dev,
 locales-all
Standards-Version: 4.1.3
Homepage: http://www.clisp.org/
Vcs-Git: https://salsa.debian.org/common-lisp-team/clisp.git
Vcs-Browser: https://salsa.debian.org/common-lisp-team/clisp

Package: clisp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: lisp-compiler, ${clisp:fasl-version}, ${clisp:memfile-hash}
Suggests: gdb,
          clisp-doc,
          slime,
          clisp-module-berkeley-db,
          clisp-module-clx,
          clisp-module-dbus,
          clisp-module-gdbm,
          clisp-module-pcre,
          clisp-module-postgresql,
          clisp-module-zlib
Breaks: clisp-dev (<< 1:2.49.20180212),
        clisp-module-rawsock (<< 1:2.49.20180212),
        clisp-module-bindings-glibc (<< 1:2.49.20180212)
Replaces: clisp-dev (<< 1:2.49.20180212),
          clisp-module-rawsock (<< 1:2.49.20180212),
          clisp-module-bindings-glibc (<< 1:2.49.20180212)
Description: GNU CLISP, a Common Lisp implementation
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 It is Free Software and may be distributed under the terms of GNU GPL,
 while it is possible to distribute commercial proprietary applications
 compiled with GNU CLISP.
 .
 The user interface comes in English, German, French, Spanish, Dutch,
 Russian and Danish, and can be changed during run time.
 .
 GNU CLISP includes an interpreter, a compiler, a debugger, CLOS, MOP,
 a foreign language interface, a socket interface, i18n, fast bignums,
 arbitrary precision floats and more.
 An X11 interface is available through CLX, Garnet, CLUE/CLIO.
 GNU CLISP runs Maxima, ACL2 and many other Common Lisp packages.
 .
 This package contains the main CLISP executable, the link-kit, and the
 following modules: i18n, regexp, syscalls, readline, ASDF, rawsock,
 bindings/glibc.

Package: clisp-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GNU CLISP, a Common Lisp implementation (documentation)
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This package contains the documentation for CLISP.

Package: clisp-module-berkeley-db
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds an interface to Berkeley DB
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This package adds a module to CLISP that implements an interface to the
 Berkeley DB.

Package: clisp-module-pcre
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds libpcre support
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements an interface to the
 libpcre which implements Perl-compatible regular expressions.

Package: clisp-module-postgresql
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds a PostgreSQL interface
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements an interface to the
 PostgreSQL DB using the C bindings.

Package: clisp-module-clx
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds X11 bindings
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements an interface to the
 X11 called CLX.

Package: clisp-module-dbus
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds an interface to D-Bus
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements an interface to the
 D-Bus system.

Package: clisp-module-gdbm
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds an interface to GNU DBM
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements an interface to
 GNU DBM.

Package: clisp-module-zlib
Architecture: any
Depends: ${shlibs:Depends}, clisp (= ${binary:Version}), ${misc:Depends}
Enhances: clisp
Description: GNU CLISP module that adds zlib support for vectors
 GNU CLISP is a Common Lisp implementation.
 It conforms to the ANSI Common Lisp standard, and offers many extensions.
 It runs on all desktop operating systems (GNU and Unix systems, macOS,
 Windows) and is particularly memory-efficient.
 .
 This adds a module to CLISP that implements a zlib interface,
 allowing you to compress vectors using zlib.

=== debian/rules ===
#!/usr/bin/make -f

# Disable -fstack-protector-strong
export DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotectorstrong

%:
	dh $@ --builddirectory=debian/build --no-parallel

override_dh_auto_configure:
	./configure debian/build CFLAGS="${CFLAGS}" \
		--prefix=/usr \
		--fsstnd=debian \
		--with-dynamic-ffi \
		--with-dynamic-modules \
		--with-module=gdbm \
		--with-module=berkeley-db \
		--with-module=pcre \
		--with-module=rawsock \
		--with-module=clx/new-clx \
		--with-module=bindings/glibc \
		--with-module=postgresql \
		--with-module=zlib \
		--with-module=dbus \
		--with-module=asdf

override_dh_install:
	dh_install
	# remove unwanted upstream doc/ files
	rm -f debian/clisp-doc/usr/share/doc/clisp/doc/clisp.1 \
		debian/clisp-doc/usr/share/doc/clisp/doc/clisp-link.1 \
		debian/clisp-doc/usr/share/doc/clisp/COPYRIGHT \
		debian/clisp-doc/usr/share/doc/clisp/GNU-GPL
	# Remove unwanted demos in /usr/lib (they are already shipped under /usr/share/doc/)
	rm -rf debian/clisp-module-clx/usr/lib/clisp-*/clx/new-clx/demos/

override_dh_installchangelogs:
	dh_installchangelogs src/ChangeLog

override_dh_gencontrol-arch:
	# add FAS file format version to substvars
	debian/clisp/usr/bin/clisp -Efile utf-8 -B debian/clisp/usr/lib/clisp-* -M debian/clisp/usr/lib/clisp-*/base/lispinit.mem debian/fasl-version.lisp
	# add memfile hash to substvars
	echo "clisp:memfile-hash=clisp-memfile-hash-$$(debian/clisp/usr/bin/clisp -B debian/clisp/usr/lib/clisp-* -memfile-hash)" >> debian/clisp.substvars
	dh_gencontrol -a
